// Direct2D gpۂɗp郆jbg
unit UnitD2D;

interface

uses
   Windows, Graphics, Direct2D, D2D1 ;

var
   D2DCanvas : TDirect2DCanvas ;    // Direct2DpLoX
   D2DCanvasFlag : Boolean ;        // Direct2DpLoXp\łTrue

   function  D2_Check  : Boolean ;
   procedure D2_Init(h:HWND) ;
   procedure D2_End ;
   procedure D2_AntiA(a:Boolean) ;                          overload;
   procedure D2_AntiA(t:Boolean; a:Boolean) ;               overload;
   procedure D2_CLS(col:TColor) ;                           overload;
   procedure D2_CLS(t:Boolean; col:TColor) ;                overload;
   procedure D2_PenColor(col : Integer);                    overload;
   procedure D2_PenColor(t:Boolean; col : Integer);         overload;
   procedure D2_PenWidth(wid : Integer);                    overload;
   procedure D2_PenWidth(t:Boolean; wid : Integer);         overload;
   procedure D2_Point(x,y,r : Integer);                     overload;
   procedure D2_Point(t:Boolean; x,y,r : Integer);          overload;
   procedure D2_Line(x1,y1, x2,y2:Integer);                 overload;
   procedure D2_Line(t:Boolean; x1,y1, x2,y2:Integer);      overload;
   procedure D2_Draw(x,y:Integer;g:TGraphic);
   procedure D2_SDraw(x1,y1,x2,y2:Integer;g:TGraphic);

implementation

// Direct2Dp\ǂmF
//    True  : OK
//    False : NG
function D2_Check : Boolean ;
begin
   D2DCanvasFlag := False ;
   Result := False ;
   if TDirect2DCanvas.Supported then
      Result := True ;
end;

// Direct2D̏
//    h: `Windownh
procedure D2_Init(h:HWND) ;
begin
   D2DCanvasFlag := False ;
   try
      D2DCanvas := TDirect2DCanvas.Create(h);
      D2DCanvasFlag := True ;
   except
      ;
   end;
end;

// Direct2D̏I
procedure D2_End ;
begin
   if (D2DCanvasFlag) then
      D2DCanvas.Free;
end;

// A`GCAX̐ݒ
//    a : True : siftHgj@False : sȂ
//    A`GCAXsYł邪`͂xij}ꍇ͂Ȃxj
//    A`GCAXsȂꍇ́A]Ɠl̕`ŁAx͂⑬
procedure D2_AntiA(a:Boolean) ;
begin
   if not(D2DCanvasFlag) then exit;
   with D2DCanvas do begin
      BeginDraw;
      if (a) then
         RenderTarget.SetAntialiasMode(D2D1_ANTIALIAS_MODE_PER_PRIMITIVE)
      else
         RenderTarget.SetAntialiasMode(D2D1_ANTIALIAS_MODE_ALIASED);
      EndDraw ;
   end;
end;

// A`GCAX̐ݒiDirect2D`FbNEAspj
//    a : True : siftHgj@False : sȂ
procedure D2_AntiA(t:Boolean; a:Boolean) ;
begin
   with D2DCanvas do begin
      if (a) then
         RenderTarget.SetAntialiasMode(D2D1_ANTIALIAS_MODE_PER_PRIMITIVE)
      else
         RenderTarget.SetAntialiasMode(D2D1_ANTIALIAS_MODE_ALIASED);
   end;
end;

// wiFw肵ĉʃNA
//    col : Fl
procedure D2_CLS(col:TColor) ;
begin
   if not(D2DCanvasFlag) then exit;
   with D2DCanvas do begin
      BeginDraw;
      RenderTarget.Clear(D2D1ColorF(col));
      EndDraw ;
   end;
end;

// wiFw肵ĉʃNAiDirect2D`FbNEAspj
//    col : Fl
procedure D2_CLS(t:Boolean; col:TColor) ;
begin
   with D2DCanvas do begin
      RenderTarget.Clear(D2D1ColorF(col));
   end;
end;

// yF
procedure D2_PenColor(col : Integer);
begin
   if not(D2DCanvasFlag) then exit;
   with D2DCanvas do begin
      Pen.Color := col ;
   end;
end;

// yF
procedure D2_PenColor(t:Boolean; col : Integer);
begin
   with D2DCanvas do begin
      Pen.Color := col ;
   end;
end;

// y
procedure D2_PenWidth(wid : Integer);
begin
   if not(D2DCanvasFlag) then exit;
   with D2DCanvas do begin
      Pen.Width := wid ;
   end;
end;

// y
procedure D2_PenWidth(t:Boolean; wid : Integer);
begin
   with D2DCanvas do begin
      Pen.Width := wid ;
   end;
end;

// _hׂ~}
procedure D2_Point(x,y,r : Integer);
begin
   if not(D2DCanvasFlag) then exit;
   with D2DCanvas do begin
      BeginDraw;
      Pen.Width := 1 ;
      Brush.Color := Pen.Color ;
      Brush.Style := bsSolid ;
      FillEllipse(D2D1Ellipse(D2D1PointF(x,y) , r,r));
      EndDraw ;
   end;
end;

// _hׂ~}
procedure D2_Point(t:Boolean; x,y,r : Integer);
begin
   with D2DCanvas do begin
      Pen.Width := 1 ;
      Brush.Color := Pen.Color ;
      Brush.Style := bsSolid ;
      FillEllipse(D2D1Ellipse(D2D1PointF(x,y) , r,r));
   end;
end;

// }
//    x1,y1 : n_XN[W(dot)
//    x2,y2 : I_XN[W(dot)
procedure D2_Line(x1,y1, x2,y2 : Integer);
begin
   if not(D2DCanvasFlag) then exit;
   with D2DCanvas do begin
      BeginDraw;
      DrawLine(D2D1PointF(x1,y1),D2D1PointF(x2,y2));
      EndDraw ;
   end;
end;
{
̍}́AL̂悤Ȏ@ł\
var
   b : ID2D1Brush ;
begin
   if not(D2DCanvasFlag) then exit;
   with D2DCanvas do begin
      BeginDraw;
      b := CreateBrush(clBlue);
      RenderTarget.DrawLine(D2D1PointF(x1,y1),D2D1PointF(x2,y2),b,5.0); // u5v͐
      EndDraw ;
   end;
end;
}
// }iDirect2D`FbNEAspj
//    x1,y1 : n_XN[W(dot)
//    x2,y2 : I_XN[W(dot)
procedure D2_Line(t:Boolean; x1,y1, x2,y2 : Integer);
begin
   with D2DCanvas do begin
      DrawLine(D2D1PointF(x1,y1),D2D1PointF(x2,y2));
   end;
end;

procedure D2_Draw(x,y:Integer;g:TGraphic);
begin
   if not(D2DCanvasFlag) then exit;
   with D2DCanvas do begin
      BeginDraw;
      Draw(x,y,g);
      EndDraw ;
   end;
end;

procedure D2_SDraw(x1,y1,x2,y2:Integer;g:TGraphic);
var
   r : TRect ;
begin
   if not(D2DCanvasFlag) then exit;
   r.Left   := x1 ;
   r.Top    := y1 ;
   r.Right  := x2 ;
   r.Bottom := y2 ;
   with D2DCanvas do begin
      BeginDraw;
      StretchDraw(r,g);
      EndDraw ;
   end;
end;

end.
